//+------------------------------------------------------------------+
//|                                              NewsTrader_v5.4.mq4 |
//|                        Copyright  2007-09, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007-09, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <WebGet.mqh>
#include <stdlib.mqh>

//---- input parameters
extern string     ExpertName       = "NewsTrader_v5.4";

extern int        Magic            =   11111;
extern int        Slippage         =       6;

extern string     Main_Parameters  = " Trade Volume & Trade Method";
extern int        CalendarID       =       4; // Calendar's ID on calendar.forex-tsd.com  
extern double     Lots             =     0.1; // Lot size
extern int        TimeGap          =       2; // Time Gap between News Time and Order Open Time in min 
extern int        OrderDuration    =      30; // Order Duratiton Time in min
extern int        ProcessTime      =       2; // Order processing Time in min
extern int        SessionEnd       =      23; // Session End Time
extern int        FridayEnd        =      22; // Session End Time in Friday
extern int        OrdersNum        =       3; // Number of pending orders from one side
extern double     PendOrdGap       =      10; // Gap for Pending Orders from current price in pips
extern double     OrdersStep       =       5; // Step between orders in pips
extern int        DelOpposite      =       0; // Switch of orders deleting: 0-off,1-on
extern int        TrailOpposite    =       1; // Trailing of Opposite Orders: 0-off,1-on
extern double     TakeProfit       =      20; // Take Profit in pips       	
extern double     TrailingStop     =      10; // Trailing Stop in pips      
extern double     InitialStop      =      50; // Initial Stop in pips 
extern double     BreakEven        =      15; // Breakeven in pips  
extern double     PipsLock         =       0; // Lock in pips
extern bool       ECN_Mode         =   false; // ECN Mode 
extern bool       Straddle_Mode    =    true; // Straddle Mode 
extern bool       DisplayLine      =    true; // Display Line Option (Visualization mode) 
extern bool       DisplayText      =   false; // Display Text Option (Visualization mode)
extern bool       DisplayLevels    =    true; // Display Levels for ECN Mode

extern string     cFilter          = " Currency Filter ";
extern bool       USD              =    true;
extern bool       EUR              =    true;
extern bool       GBP              =    true;
extern bool       JPY              =    true;
extern bool       AUD              =    true;
extern bool       CAD              =    true;
extern bool       CHF              =    true;
extern bool       NZD              =    true;

extern string     rFilter          = " Rating Filter ";
extern int        MaxRating        =       3;
extern int        MinRating        =       1;  

extern string     MM_Parameters    = " MoneyManagement";
extern bool       MM               =   false; //  Switch
extern double     MaxRisk          =    0.04; // Risk Factor


datetime FinTime=0;
string   sDate[];          // Date
string   sTime[];          // Time
string   sCurrency[];      // Currency
string   sDescription[];   // Description
string   sRating[];        // Rating
string   sActual[];        // Actual value
string   sForecast[];      // Forecast value
string   sPrevious[];      // Previous value
string   sImpact[];
datetime dt[];
double   BuyLevel[], SellLevel[];
int      BEvent=0, NewsNum, TriesNum=5, BuyEvent, SellEvent;
string   CalendarName;
bool     fTime;
datetime prevTime,OpenTime=0;
int      totalPips=0, TimeZone = 0, pEventTime;
double   totalProfits=0;
double   _Point, pAsk, pBid, minstop;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//---- 
   fTime = true;
   _Point = MarketInfo(Symbol(),MODE_POINT)*MathPow(10,Digits%2);
   minstop= MarketInfo(Symbol(),MODE_STOPLEVEL)/MathPow(10,Digits%2);
   
   ArrayResize(BuyLevel ,OrdersNum);
   ArrayResize(SellLevel,OrdersNum);
   pEventTime = TimeCurrent(); 
//----
return(0);
}
  
// ---- Money Management
double MoneyManagement()
{
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract=MarketInfo(Symbol(),MODE_LOTSIZE);
   double vol;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
//--- basic formula
   if ( MM )
   vol=NormalizeDouble(AccountFreeMargin()*MaxRisk*AccountLeverage()/contract,2);
   else
   vol=Lots;
//--- check min, max and step
   vol=NormalizeDouble(vol/lot_step,0)*lot_step;
   if(vol<lot_min) vol=lot_min;
   if(vol>lot_max) vol=lot_max;
//---
   return(vol);
}   

// ---- Trailing Stops
void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
   int    total = OrdersTotal(); 
   
   
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode==OP_BUY) 
         {
			   if (BreakEven > 0 && BEvent < total )
			   {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/_Point;
			      if( Gain >= BreakEven && OrderStopLoss()<=OrderOpenPrice()+PipsLock*_Point) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice() + PipsLock*_Point,Digits);
			      BEvent+=1;
			      }
			   }
			   else			   
			   if (TrailingStop > 0) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*_Point,Digits);
			   			   
			   if (MathAbs(Ask - BuyStop) < minstop*_Point) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) - minstop*_Point,Digits);   
             
			   if( NormalizeDouble(OrderOpenPrice(),Digits)<= BuyStop) 
            {   
			      if (BuyStop > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              BuyStop,
			                              OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
            if (BreakEven > 0 && BEvent > -total)
			   {
			   Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/_Point;
			   
			      if( Gain >= BreakEven && (OrderStopLoss()>=OrderOpenPrice()-PipsLock*_Point || OrderStopLoss()== 0)) 
			      {
			      double SellStop = NormalizeDouble(OrderOpenPrice()-PipsLock*_Point,Digits);
			      BEvent-=1;
			      }
			   }
			   else 
			   if (TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*_Point,Digits);   
                        
            if (MathAbs(Bid - SellStop) < minstop*_Point) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + minstop*_Point,Digits);   
                        
            if(NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop>0) 
            {
               if( SellStop < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              SellStop,
			                              OrderTakeProfit(),0,Orange);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   			}	    
         }
      }
   }     
}


// ---- Open Sell Orders
int SellOrdOpen(int ord,double price,double sl,double tp,int num) 
{		     
   int ticket = 0;
   int tr = 1;
      
   while ( ticket <= 0 && tr <= TriesNum)
   {
   ticket = OrderSend( Symbol(),ord,MoneyManagement(),
	                    NormalizeDouble(price , Digits),
	                    Slippage,
	                    NormalizeDouble(sl, Digits),
	                    NormalizeDouble(tp, Digits),
	                    ExpertName+" SELL:"+num,Magic,0,Red);
      
      if(ticket > 0) 
      {
      BEvent=0;   
         if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
         Print("SELL order opened : ", OrderOpenPrice());
      }
	   else 	
      if(ticket < 0)
	   { 	
      Sleep(5000);
      RefreshRates();
      tr += 1;
      if(GetLastError()>0)
      Print("SELL: OrderSend failed with error #",ErrorDescription(GetLastError()));
      }
   }   
   return(ticket);
}

// ---- Open Buy Orders
int BuyOrdOpen(int ord,double price,double sl,double tp,int num)
{		     
   int ticket = 0;
   int tr = 1;
      
   while ( ticket <= 0 && tr <= TriesNum)
   {
   ticket = OrderSend(Symbol(),ord,MoneyManagement(),
	                   NormalizeDouble(price , Digits),
	                   Slippage,
	                   NormalizeDouble(sl, Digits), 
	                   NormalizeDouble(tp, Digits),
	                   ExpertName+" BUY:"+num,Magic,0,Blue);
      
      if(ticket > 0) 
      {
      BEvent=0;
         if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
         Print("BUY order opened : ", OrderOpenPrice());
      
      }
      else 
	   if(ticket < 0)
	   { 	
      Sleep(5000);
      RefreshRates();
      tr += 1;
      if(GetLastError()>0)      
      Print("BUY : OrderSend failed with error #",ErrorDescription(GetLastError()));
      }
   }   
   return(ticket);
} 

// ---- Scan Trades

int ScanTrades(int ord,int mode)
{   
   int total = OrdersTotal();
   int numords = 0;
   bool type = false; 
   int trd = 0;
   
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if ( ord != 0 )
   {
   if ( OrderType()==0 || OrderType()==2 || OrderType()==4 ) trd =  1;
   if ( OrderType()==1 || OrderType()==3 || OrderType()==5 ) trd =  2;      
   } else trd=0;
   
   if (mode == 0) type = OrderType()<=OP_SELLSTOP;
   if (mode == 1) type = OrderType()<=OP_SELL;   
   if (mode == 2) type = OrderType()>OP_SELL && OrderType()<=OP_SELLSTOP; 
   
   if(OrderSymbol() == Symbol() && type && trd==ord && OrderMagicNumber() == Magic)  
   numords++;
   }
   return(numords);
}  

datetime FinishTime(int Duration)
{   
   int total = OrdersTotal();
   datetime ftime=0;
         
   for(int i=0; i<total; i++) 
   {        
   OrderSelect(i, SELECT_BY_POS);            
   
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   ftime=OrderOpenTime()+ Duration*60;
   }
   
   return(ftime);
}

// Closing of Pending Orders      
void PendOrdDel(int mode)
{
   bool result = false;
   
   for (int i=0; i<OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if ( Symbol()==OrderSymbol() && OrderMagicNumber()==Magic)     
      {
         if((mode==0 || mode==1) && OrderType()==OP_BUYSTOP)
         {     
         result = OrderDelete(OrderTicket());
         if(!result) Print("BUYSTOP: OrderDelete failed with error #",GetLastError());
         }
         else
         if((mode==0 || mode==2) && OrderType()==OP_SELLSTOP)
         {     
         result = OrderDelete( OrderTicket() );  
         if(!result) Print("SELLSTOP: OrderDelete failed with error #",GetLastError());
         }
      }
   }
}    

//-----
void ReadnPlotCalendar(string fName)
{    
   int i, k, handle;
   bool rates=false;
   
   ArrayResize(sDate,0);
   ArrayResize(sTime,0);
   ArrayResize(sCurrency,0);
   ArrayResize(sDescription,0);
   ArrayResize(sRating,0);
   ArrayResize(sActual,0);
   ArrayResize(sForecast,0);
   ArrayResize(sPrevious,0);
   ArrayResize(sImpact,0);
   ArrayResize(dt,0);
   
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
   if(handle<1)
   {
   Print("File not found ", GetLastError());
   return(false);
   }
   else
   {
   i=0;
      while(!FileIsEnding(handle))
      {
      k = ArraySize(sDate);
   
      ArrayResize(sDate,k + 1);
      ArrayResize(sTime,k + 1);
      ArrayResize(sCurrency,k + 1);
      ArrayResize(sDescription,k + 1);
      ArrayResize(sRating,k + 1);
      ArrayResize(sActual,k + 1);
      ArrayResize(sForecast,k + 1);
      ArrayResize(sPrevious,k + 1);
      ArrayResize(sImpact,k + 1);
      ArrayResize(dt,k + 1);
      
      sDate[i]=FileReadString(handle);          // Date
      sTime[i]=FileReadString(handle);          // Time
      sCurrency[i]=FileReadString(handle);      // Currency
      sDescription[i]=FileReadString(handle);   // Description
      sRating[i]=FileReadString(handle);        // Rating
      sActual[i]=FileReadString(handle);        // Actual value
      sForecast[i]=FileReadString(handle);      // Forecast value
      sPrevious[i]=FileReadString(handle);      // Previous value
           
      int rating = StrToInteger(sRating[i]);
      rates = rating <= MaxRating && rating >= MinRating;
   
      if(!rates) continue;
   
      if ((sCurrency[i] == "USD") && (!USD) ) continue;            
      if ((sCurrency[i] == "EUR") && (!EUR) ) continue;            
      if ((sCurrency[i] == "GBP") && (!GBP) ) continue;                      
      if ((sCurrency[i] == "JPY") && (!JPY) ) continue;
      if ((sCurrency[i] == "AUD") && (!AUD) ) continue;
      if ((sCurrency[i] == "CAD") && (!CAD) ) continue;                     
      if ((sCurrency[i] == "CHF") && (!CHF) ) continue;  
      if ((sCurrency[i] == "NZD") && (!NZD) ) continue;   
       
      dt[i] = StrToTime(sDate[i]+" "+sTime[i])+TimeZone*3600;
   
      if(rating == 3) sImpact[i] = "High";
      if(rating == 2) sImpact[i] = "Medium";
      if(rating == 1) sImpact[i] = "Low";
   
      string info = i+"_"+TimeToStr(dt[i])+" "+sCurrency[i]+" "+" "+sDescription[i]+" "+sImpact[i];
      //Print( info );
      
      color c=Yellow ;
   
      if (sCurrency[i] == "USD") c = Blue;  
      if (sCurrency[i] == "EUR") c = Pink; 
      if (sCurrency[i] == "GBP") c = Red;
      if (sCurrency[i] == "JPY") c = Orange;            
      if (sCurrency[i] == "AUD") c = Green;       
      if (sCurrency[i] == "CAD") c = Gray;
      if (sCurrency[i] == "CHF") c = Green;
      if (sCurrency[i] == "NZD") c = Lime;  
      
         if (DisplayText)
         {
         ObjectCreate("NTT"+i, OBJ_TEXT, 0, dt[i], Close[0]);
         ObjectSet("NTT"+i, OBJPROP_COLOR, c);          
         ObjectSetText("NTT"+i,sCurrency[i] + " " + sDescription[i] + " ",8);          
         ObjectSet("NTT"+i, OBJPROP_ANGLE, 90);          
         }
          
         if (DisplayLine)
         {         
         ObjectCreate("NTL"+i, OBJ_VLINE, 0, dt[i], Close[0]);
         ObjectSet("NTL"+i, OBJPROP_COLOR, c);                    
         ObjectSet("NTL"+i, OBJPROP_STYLE, STYLE_DOT);                    
         ObjectSet("NTL"+i, OBJPROP_BACK, true);          
         ObjectSetText("NTL"+i,sCurrency[i] + " " + sDescription[i],8);          
         }
  
      i++;
      }
   NewsNum = i; // ArraySize(sDate);
   }
   return(0);
}

//----
void ObjDel()
{
   int _GetLastError;
   if(DisplayLine && DisplayText) int obtotal = 0.5*ObjectsTotal(); else obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
      if (DisplayLine)
      if ( !ObjectDelete( StringConcatenate( "NTL", i ) ) )
      {
      _GetLastError = GetLastError();
      //Print( "ObjectDelete( \"", StringConcatenate( "NTL", i ),"\" ) - Error #", _GetLastError );
      }
      
      if (DisplayText)
      if( !ObjectDelete( StringConcatenate( "NTT", i ) ) )
      {
      _GetLastError = GetLastError();
      //Print( "ObjectDelete( \"", StringConcatenate( "NTT", i ),"\" ) - Error #", _GetLastError );
      }
   }
}
//-----
void ArrowsDel()
{
   int _GetLastError;
   if(DisplayLevels) int obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
      if(DisplayLevels)
      {
         if(!ObjectDelete(StringConcatenate("bECNL", i))) 
         {
         _GetLastError = GetLastError();
         //Print( "ObjectDelete( \"", StringConcatenate( "bECNL", i ),"\" ) - Error #", _GetLastError );
         }
         
         if(!ObjectDelete(StringConcatenate("sECNL", i)))
         {
         _GetLastError = GetLastError();
         //Print( "ObjectDelete( \"", StringConcatenate( "sECNL", i ),"\" ) - Error #", _GetLastError );
         }
      }
   }     
}
//---- Close of Orders

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=0; i<=total; i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) 
      {
      if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) result=CloseAtMarket(OrderTicket(),OrderLots(),Aqua);
      if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) result=CloseAtMarket(OrderTicket(),OrderLots(),Pink);
      }
   }
}


bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      ntr=0; 
      while (ntr<5 && !IsTradeAllowed()) { ntr++; Sleep(5000); }
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}
//------
int TimeToOpen()
{
   int result = 0;
      
   if(ECN_Mode) int ProcTime = OrderDuration;
   else ProcTime = ProcessTime;
   
   for (int i=0; i<=NewsNum; i++)
   { 
   datetime oTime = dt[i] - TimeGap*60;
   
      if(TimeCurrent()>= oTime && TimeCurrent() <= oTime + ProcTime * 60 && oTime >= pEventTime)
      {
      result = oTime; 
      break;
      }
   }
      
   return(result);
}
//-----
bool IsNewEvent()
{
   bool result = false;
        
   for (int i=0; i < NewsNum; i++)
   { 
   datetime oTime = dt[i] - TimeGap*60;
   
      if(TimeCurrent()>= oTime && oTime > pEventTime)
      {
      result = true; 
      pEventTime = oTime;
      break;
      }
   }
   return(result);
}
//-----        
void TrailOppositeOrder(int mode)
{
   int    error;  
   bool   result=false;
   double Gain = 0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode == 1 && OrderType() == OP_BUYSTOP) 
         {
			double BuyPrice = MarketInfo(Symbol(),MODE_ASK);   
			   for( int nt=1; nt<=OrdersNum; nt++)
            {
			      if (VerifyComment(1,nt))
			      {
			      double mBuyPrice = NormalizeDouble(BuyPrice + (2*PendOrdGap+OrdersStep*(nt-1))*_Point,Digits);
		         if (InitialStop > 0) double mBuyStop =  mBuyPrice - InitialStop*_Point; else mBuyStop=0;
               if (TakeProfit  > 0) double mBuyProfit= mBuyPrice + TakeProfit*_Point;  else mBuyProfit=0; 
			   			     
			         if(NormalizeDouble(OrderOpenPrice(),Digits) > mBuyPrice) 
                  {   
			            for(int k = 0 ; k < TriesNum; k++)
                     {
                     result = OrderModify(OrderTicket(),mBuyPrice,
			                                 NormalizeDouble(mBuyStop,Digits),
			                                 NormalizeDouble(mBuyProfit,Digits),0,Aqua);
                     error=GetLastError();
                        if(error==0) break;
                        else {Sleep(5000); RefreshRates(); continue;}
                     }
                  }      		 
               }            
            }
         }   
// - SELL Orders          
         if (mode==2 && OrderType() == OP_SELLSTOP)
         {
         double SellPrice= MarketInfo(Symbol(),MODE_BID);  
            for( nt=1; nt<=OrdersNum; nt++)
            {
               if (VerifyComment(2,nt))
			      {
               double mSellPrice= NormalizeDouble(SellPrice - (2*PendOrdGap+OrdersStep*(nt-1))*_Point,Digits);
		         if (InitialStop > 0) double mSellStop  = mSellPrice + InitialStop*_Point; else mSellStop=0;
               if (TakeProfit  > 0) double mSellProfit= mSellPrice - TakeProfit*_Point;  else mSellProfit=0;  	   
         
                  if(NormalizeDouble(OrderOpenPrice(),Digits) < mSellPrice) 
                  {
                     for( k = 0 ; k < TriesNum; k++)
                     {
                     result = OrderModify(OrderTicket(),mSellPrice,
			                                 NormalizeDouble(mSellStop,Digits),
			                                 NormalizeDouble(mSellProfit,Digits),0,Magenta);
                     error=GetLastError();
                        if(error==0) break;
                        else {Sleep(5000); RefreshRates(); continue;}
                     }
                  }   
               }   
   			}	    
         }
      }
   }     
}

bool VerifyComment(int mode, int num)
{
   int total = OrdersTotal();
   bool result = false; 
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
      if (mode==1 && OrderComment() == ExpertName+" BUY:"+num)  
      {
      result=true;
      break;
      }
      
      if (mode==2 && OrderComment() == ExpertName+" SELL:"+num) 
      {
      result=true;
      break;
      }
   }
  
   return(result);
}                                   

string ForexTSD_Calendar()
{
   datetime StartWeek = iTime(NULL,PERIOD_W1,0);
   string StartYear  = TimeYear (StartWeek);
   if (TimeMonth(StartWeek)>10) string StartMonth = TimeMonth(StartWeek);
   else StartMonth = "0" + TimeMonth(StartWeek);
   if (TimeDay(StartWeek)>10) string StartDay   = TimeDay(StartWeek);
   else StartDay = "0" + TimeDay(StartWeek);
   
   string StartTime = StartYear + StartMonth + StartDay;  
      
   string WebAdress = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+StartTime+"&calendar[]="+CalendarID;
   string result = forextsd_com_webget(WebAdress);
      
   if(result != "") 
   {
   string CalName = "Calendar_"+StartYear+"-"+StartMonth+"-"+StartDay+".csv";
   
   Print(CalName," is OK");
   
   int handle=FileOpen(CalName,FILE_CSV|FILE_WRITE,';');
         
      if(handle>0)
      {
      FileWrite(handle, result);
      FileClose(handle);
      }
   }
   else CalName = "";
  
   return(CalName);   
}

void ChartComment()
{
   
   string sComment   = "";
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   string upcomNews  = "";
   string upcomTime  = "";
   string prevNews   = "";
   string prevTime   = "";
   string nextNews   = "";
   string nextTime   = "";
   
   TotalProfit();    
   int prTime = 0; 
   int upTime = 0;
   int nxTime = 0;
   
   for (int i=0; i <= NewsNum; i++)
   { 
      if((TimeCurrent() > dt[i-1] && TimeCurrent() <= dt[i]) || (upTime == dt[i] && TimeCurrent() <= dt[i]))
      {
         if(upTime == dt[i] && sDescription[i] != sDescription[i-1])   
         {
         upcomNews = upcomNews + (sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i]+NL); 
         upcomTime = TimeToStr(upTime);  
         }
         else
         {
         upcomNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i] + NL; 
         upcomTime = TimeToStr(dt[i]);  
         }
      upTime = dt[i];
      }   
      
      if(TimeCurrent() > dt[i-1])
      {
         if(prTime == dt[i-1] && sDescription[i-1] != sDescription[i-2])   
         {
         prevNews = prevNews + (sCurrency[i-1]+" "+sDescription[i-1]+" Impact=" + sImpact[i-1] + NL); 
         prevTime = TimeToStr(prTime);
         }
         else
         {
         prevNews = sCurrency[i-1]+" "+sDescription[i-1]+" Impact=" + sImpact[i-1] + NL; 
         prevTime = TimeToStr(dt[i-1]);
         }
      
      if(i == 0) {prevNews =""; prevTime = "";}  
      prTime = dt[i-1];
      }
      
      if(upTime > 0 && upTime < dt[i])
      {
         if(dt[i] > nxTime && nxTime > 0) break;
         if(nxTime == dt[i] && sDescription[i] != sDescription[i-1])
         {      
         nextNews = nextNews + (sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i] + NL);
         nextTime = TimeToStr(nxTime);
         }
         else
         {
         nextNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i] + NL;
         nextTime = TimeToStr(dt[i]);
         }
      nxTime = dt[i];
      }
   }
   
   
   sComment = sp;
   sComment = sComment+"ExpertName : "+ExpertName+NL;
   
   if(TimeZone >= 0)
   sComment = sComment+"Broker\'s Name: "+AccountCompany()+ NL +"Time Zone : GMT + " + TimeZone + NL;
   else
   sComment = sComment+"Broker\'s Name: "+AccountCompany()+ NL +"Time Zone : GMT - " + DoubleToStr(MathAbs(TimeZone),0) + NL;
   
   sComment = sComment+"Orders: Open= "+ScanTrades(0,1)+" Pending= "+ScanTrades(0,2)+" All= "+ScanTrades(0,0)+NL;
   sComment = sComment+"Current Profit(pips)= " + totalPips + NL;
   sComment = sComment+"Current Profit(USD) = " + DoubleToStr(totalProfits,2) + NL + NL; 
   sComment = sComment+"NEWS :" + NL + sp;
   sComment = sComment+"-Previous: " + prevTime  + NL + prevNews;
   sComment = sComment+"-Upcoming: " + upcomTime + NL + upcomNews;
   sComment = sComment+"-Next: "     + nextTime  + NL + nextNews;
   sComment = sComment+sp;
  
   Comment(sComment);
}      

void TotalProfit()
{
   int total=OrdersTotal();
   totalPips = 0;
   totalProfits = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
   else if ( Magic==0 ) condition = true;   
      if (condition)
      {      
         switch (mode)
         {
         case OP_BUY:
            totalPips += MathRound((MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/_Point);
            totalProfits += (OrderProfit() + OrderSwap() + OrderCommission());
            break;
            
         case OP_SELL:
            totalPips += MathRound((OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/_Point);
            totalProfits += (OrderProfit() + OrderSwap() + OrderCommission());
            break;
         }
      }            
	}
}

void ECN_StopAndProfit()
{
   int    error;  
   bool   result=false;
       
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode==OP_BUY || mode == OP_BUYLIMIT || mode == OP_BUYSTOP) 
         {
			if (InitialStop > 0) double BuyStop  = OrderOpenPrice() - InitialStop*_Point; else BuyStop  =0;
         if (TakeProfit  > 0) double BuyProfit= OrderOpenPrice() + TakeProfit *_Point; else BuyProfit=0;   
			
			BuyStop = NormalizeDouble(BuyStop,Digits);
			BuyProfit = NormalizeDouble(BuyProfit,Digits);     
			   
			   if(OrderStopLoss() == 0 && OrderTakeProfit() == 0) 
            {   
			      for(int k = 0 ; k < TriesNum; k++)
               {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                           BuyStop,
			                           BuyProfit,0,Lime);
               error=GetLastError();
                  if(error==0) break;
                  else {Sleep(5000); RefreshRates(); continue;}
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL || mode == OP_SELLLIMIT || mode == OP_SELLSTOP)
         {
         if (InitialStop > 0) double SellStop  = OrderOpenPrice() + InitialStop*_Point; else SellStop  =0;
         if (TakeProfit  > 0) double SellProfit= OrderOpenPrice() - TakeProfit *_Point; else SellProfit=0;   
			               
         SellStop = NormalizeDouble(SellStop,Digits);
			SellProfit = NormalizeDouble(SellProfit,Digits);    
            
            if(OrderStopLoss() == 0 && OrderTakeProfit() == 0) 
            {
               for( k = 0 ; k < TriesNum; k++)
               {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                           SellStop,
			                           SellProfit,0,Orange);
               error=GetLastError();
                  if(error==0) break;
                  else {Sleep(5000); RefreshRates(); continue;}
               }   
   			}	    
         }
      }
   }     
}
               
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   ObjDel();
   ArrowsDel();
//----
   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(Bars < 1) {Print("Not enough bars for this strategy");return(0);}
   
   if(AccountFreeMargin()<(1000*Lots)){
   Print("We have no money. Free Margin = ", AccountFreeMargin());
   return(0);}
//---- 
   datetime cTime = iTime(NULL,PERIOD_W1,0);
     
   if (fTime || (TimeCurrent() > cTime && cTime > prevTime))
   {
   string gmt = forextsd_com_webget("http://calendar.forex-tsd.com/gmt.php");
   if(gmt!="") datetime gmtime = StrToTime(gmt);
   else return(0);
   
   int tz = NormalizeDouble((TimeCurrent() - gmtime)/3600.0,0);
   if ( tz < 24) TimeZone = tz;
   
   
   CalendarName = ForexTSD_Calendar(); 
   
      if(CalendarName != "")
      {   
      ReadnPlotCalendar(CalendarName);
      fTime = false;
      prevTime = cTime;
      }
      else 
      {
      //Print("Attention! Wrong Calendar:",CalendarName,"time=",TimeToStr(TimeCurrent())); 
      return(0);
      }
   }
   
   ChartComment();
   
   bool NewEvent = IsNewEvent(); 
   
   if (ScanTrades(0,0) > 0)
   {
      if (DelOpposite > 0)
      {
         if (ScanTrades(1,1) > 0) while(ScanTrades(2,2) > 0) PendOrdDel(2);
         if (ScanTrades(2,1) > 0) while(ScanTrades(1,2) > 0) PendOrdDel(1);
          
         if (ScanTrades(0,1) == 0 && (ScanTrades(1,2) == 0 || ScanTrades(2,2)==0)) PendOrdDel(0);
      }      
      
      datetime FinTime = FinishTime(OrderDuration); 
      if (TimeCurrent()>=FinTime) while(ScanTrades(0,2) > 0) PendOrdDel(0); 
      
      if(DayOfWeek()!=5) datetime EndTime = StrToTime(SessionEnd+":00")-Period()*60; 
      else EndTime = StrToTime(FridayEnd+":00")-Period()*60;
      
      bool EOD = false;
      EOD = TimeCurrent()>= EndTime;
      
      if (NewEvent || EOD)
      {
         while(ScanTrades(0,1) > 0) CloseOrder(0);
         while(ScanTrades(0,2) > 0) PendOrdDel(0);
      }
     
      if (ECN_Mode && ScanTrades(0,0) > 0) ECN_StopAndProfit();
      
      if (ScanTrades(0,1) > 0 && (TrailingStop > 0 || BreakEven > 0)) TrailStop();
   
      if (TrailOpposite > 0 && DelOpposite == 0)
      {
      if (ScanTrades(1,1) > 0 && ScanTrades(2,2) > 0) TrailOppositeOrder(2); 
      if (ScanTrades(2,1) > 0 && ScanTrades(1,2) > 0) TrailOppositeOrder(1);
      }   
   }
   
   if(ECN_Mode && NewEvent && ScanTrades(0,0) < 1) 
   {
   BuyEvent  = 0; 
   SellEvent = 0; 
   ArrowsDel();
   }
         
   if ((!ECN_Mode && ScanTrades(0,0) < 1) || (ECN_Mode && ScanTrades(0,0) < OrdersNum))
   { 
   int OpenTime = TimeToOpen();
     
      if(OpenTime > 0)
      {
      double BuyPrice = MarketInfo(Symbol(),MODE_ASK);   
      double SellPrice= MarketInfo(Symbol(),MODE_BID);   
         for(int cnt=1; cnt<=OrdersNum; cnt++)
         {
            if(!ECN_Mode)
		      {
		      double oBuyPrice = BuyPrice + (PendOrdGap+OrdersStep*(cnt-1))*_Point;
		      if (InitialStop > 0) double BuyStop =  oBuyPrice - InitialStop*_Point; else BuyStop=0;
            if (TakeProfit  > 0) double BuyProfit= oBuyPrice +  TakeProfit*_Point; else BuyProfit=0;   
            BuyOrdOpen(OP_BUYSTOP,oBuyPrice,BuyStop,BuyProfit,cnt); 
            }
            else
            if(ECN_Mode && ((!Straddle_Mode && ScanTrades(2,1)) || Straddle_Mode))
            {
            BuyStop=0; 
            BuyProfit=0;
               if(BuyEvent == 0)
               {
               BuyLevel[cnt-1] = BuyPrice + (PendOrdGap+OrdersStep*(cnt-1))*_Point;
                  if (DisplayLevels)
                  {         
                  ObjectCreate("bECNL"+cnt, OBJ_ARROW, 0, OpenTime,BuyLevel[cnt-1]);
                  ObjectSet("bECNL"+cnt, OBJPROP_ARROWCODE, 1);
                  ObjectSet("bECNL"+cnt, OBJPROP_COLOR, LightBlue);                    
                  ObjectSetText("bECNL"+cnt,Symbol() + " " + "Buy Level #" + cnt,8);          
                  }
               
               if(cnt == OrdersNum) BuyEvent = 1;
               } 
               
               if(Ask >= BuyLevel[cnt-1] && pAsk < BuyLevel[cnt-1] && !VerifyComment(1,cnt))
               { 
               BuyOrdOpen(OP_BUY,Ask,BuyStop,BuyProfit,cnt); 
               }
            }
         
            if(!ECN_Mode)
		      {
            double oSellPrice = SellPrice - (PendOrdGap+OrdersStep*(cnt-1))*_Point;
		      if (InitialStop > 0) double SellStop  = oSellPrice + InitialStop*_Point; else SellStop=0;
            if (TakeProfit  > 0) double SellProfit= oSellPrice - TakeProfit*_Point ; else SellProfit=0;
            SellOrdOpen(OP_SELLSTOP,oSellPrice,SellStop,SellProfit,cnt);
            }
            else
            if(ECN_Mode && ((!Straddle_Mode && ScanTrades(1,1) == 0) || Straddle_Mode))
            {
            SellStop=0; 
            SellProfit=0;
               if(SellEvent == 0)
               {
               SellLevel[cnt-1] = SellPrice - (PendOrdGap+OrdersStep*(cnt-1))*_Point;
                  if (DisplayLevels)
                  {         
                  ObjectCreate("sECNL"+cnt, OBJ_ARROW, 0, OpenTime,SellLevel[cnt-1]);
                  ObjectSet("sECNL"+cnt, OBJPROP_ARROWCODE, 2); 
                  ObjectSet("sECNL"+cnt, OBJPROP_COLOR, Tomato);                    
                  ObjectSetText("sECNL"+cnt,Symbol() + " " + "Sell Level #" + cnt,8);          
                  }
               if(cnt == OrdersNum) SellEvent = 1;
               } 
               if(Bid <= SellLevel[cnt-1] && pBid > SellLevel[cnt-1] && !VerifyComment(2,cnt))
               { 
               SellOrdOpen(OP_SELL,Bid,SellStop,SellProfit,cnt);
               }
            }
         }
      }
   }
   pBid = Bid; 
   pAsk = Ask;  
      
   return(0);
}//int start
//+------------------------------------------------------------------+





